/*
 * Objekt.java
 *
 * Created on 12. Mai 2002, 19:30
 */

package gpa;

/**
 *
 * @author  andreas
 */
public class Objekt {
    
    /** Creates a new instance of Objekt */
    public Objekt(int p_nummer, boolean ioderp) {
        nummer=p_nummer;
        verzeichnis = new String();
        if (ioderp) {
            verzeichnis = "inventar/";
        }
        else {
            verzeichnis = "personen/";
        }
        werteEinlesen();
        attributeEinlesen(ioderp);
    }
    
    private int nummer;
    private String verzeichnis;
    private String name;
    private String beschreibung;
    public String attribute;
    public boolean aendertinventarvar;
    public boolean aendertpersonenvar;
    private String personenhinzu;
    private String personenentfernt;
    private String inventarhinzu;
    private String inventarentfernt;
    
    /** liefert die Nummer (also den eindeutigen Schlssel)
     * des Objektes zurck */
    public int nummerAusgeben() {
        return nummer;
    }
    
    /** gibt den Verzeichnisnamen aus, entweder personen oder inventar */
    public String verzeichnisAusgeben() {
        return verzeichnis;
    }
    
    /** liefert den Namen des Objektes zurck */
    public String nameAusgeben() {
        return name;
    }
    
    /** liefert die Beschreibung des Objektes zurck. Falls es keine
     * eigene Beschreibung hat, wird eine Standard-Beschreibung zurck-
     * gegeben.*/
    public String beschreibungAusgeben() {
        if (beschreibung.equals("")) {
            beschreibung = "Du kannst daran nichts besonderes erkennen: "+name;
        }      
        return beschreibung;
    }
    
    /** teilt einen String in einzelne Teile anhand eines
     * festgelegten Trennzeichens */
    public String[] split(String liste,String delim) {
        java.util.StringTokenizer puffer = new java.util.StringTokenizer(liste,delim);
        int max = puffer.countTokens();
        String[] ergebnis = new String[max];
        for (int i=0;i<max;i++) {
            ergebnis[i] = puffer.nextToken();
        }
        return ergebnis;
    }
    
    /** gibt an, ob das Objekt das Inventar ndert */
    public boolean aendertInventar() {
        return aendertinventarvar;
    }
    
    /** der ndern-Effekt soll immer nur einmal auftreten,
     * wenn er aufgetreten ist, wird ein Schalter umgelegt */
    public void hatInventarGeaendert() {
        aendertinventarvar=false;
    }

    /** gibt eine Liste mit hinzuzufgenden Inventargegenstnden aus */
    public String[] inventarHinzu() {
        return split(inventarhinzu,";");
    }

    /** gibt eine Liste mit zu entfernenden Inventargegenstnden aus */
    public String[] inventarEntfernt() {
        return split(inventarentfernt,";");
    }    
    
    /** gibt an, ob der Gegenstand die Personenliste ndert */
    public boolean aendertPersonen() {
        return aendertpersonenvar;
    }

    /** der ndern-Effekt soll immer nur einmal auftreten,
     * wenn er aufgetreten ist, wird ein Schalter umgelegt */
    public void hatPersonenGeaendert() {
        aendertpersonenvar=false;
    }
    
    /** gibt eine Liste mit hinzuzufgenden Personen aus */
    public String[] personenHinzu() {
        return split(personenhinzu,";");
    }

    /** gibt eine Liste mit zu entfernenden Personen aus */
    public String[] personenEntfernt() {
        return split(personenentfernt,";");
    }
    
    /** liest Werte ein, die sowohl Personen als auch Inventargegenstnde
     * besitzen. Eigener Name, damit die Methode von den abgeleiteten
     * Klassen nicht berschrieben wird */
    private void werteEinlesen() {
        name = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"n.gpa")));
        beschreibung = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"b.gpa")));
        attribute = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"a.gpa")));
        personenhinzu = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"pp.gpa")));
        personenentfernt = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"pm.gpa")));
        inventarhinzu = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"ip.gpa")));
        inventarentfernt = new String(Datei.inhaltAusgeben(getClass().getResource("/data/"+verzeichnis+nummer+"im.gpa")));
    }
    
    /** verarbeitet den in werteEinlesen() gelesenen Attribut-String
     * und speichert die Daten in speziellen Variablen, die dann
     * ber dazugehrige Methoden von auen ausgelesen werden knnen */
    private void attributeEinlesen(boolean ioderp) {
        try {
            aendertinventarvar = (!inventarhinzu.equals("")||!inventarentfernt.equals(""));
            aendertpersonenvar = (!personenhinzu.equals("")||!personenentfernt.equals(""));
        }
        catch (StringIndexOutOfBoundsException ungueltigeattributdatei) {
        }
    }
    
}