/*
 * Schule.java
 *
 * Created on 24. April 2002, 22:00
 */

package gpa;

/**
 *
 * @author  andreas
 */
public class Schule {
    
    /** Creates a new instance of Schule */
    public Schule(int xmax, int ymax, int zmax, int xstart, int ystart, int zstart) {
        stockwerke=xmax;
        xraeume=ymax;
        yraeume=zmax;
        xjetzt=xstart;
        yjetzt=ystart;
        zjetzt=zstart;
        raumliste = new Raum[xmax][ymax][zmax];
        uhr = new Uhrzeit();
        raumInit();
        aktuellerraum = raumliste[xstart][ystart][zstart];
    }
    
    private Raum[][][] raumliste;
    public Uhrzeit uhr;
    public Raum aktuellerraum;
    private int stockwerke;
    private int xraeume;
    private int yraeume;
    private int xjetzt;
    private int yjetzt;
    private int zjetzt;
    
    /** initialisiert das Feld mit den einzelnen Rumen.
     * Die vorgebene Liste mit Raumnummern wird in ihre Einzelteile
     * zerlegt, diese werden in einem zweidimensionalen Feld gespeichert.
     * Dann werden fr alle Eintrge neue Rume geschaffen. */
    private void raumInit() {
        String raumpuffer = new String(Datei.inhaltAusgeben((getClass().getResource("/data/meta/raumliste.gpa"))));
        java.util.StringTokenizer puffer = new java.util.StringTokenizer(raumpuffer,";");
        int max = puffer.countTokens();
        String[] vorhandeneraeume = new String[puffer.countTokens()];
        for (int i=0;i<max;i++) {
            vorhandeneraeume[i] = puffer.nextToken();
        } 
        int[][] vorhandeneraeume2 = new int[vorhandeneraeume.length][3];
        for (int i=0;i<vorhandeneraeume2.length;i++) {
            try {
                vorhandeneraeume2[i][0] = new Integer(vorhandeneraeume[i].substring(0,1)).intValue();
                vorhandeneraeume2[i][1] = new Integer(vorhandeneraeume[i].substring(1,2)).intValue();
                vorhandeneraeume2[i][2] = new Integer(vorhandeneraeume[i].substring(2,3)).intValue();
            }
            catch (StringIndexOutOfBoundsException keineraumnummer) {
                vorhandeneraeume2[i][0]=-1;
                vorhandeneraeume2[i][1]=-1;
                vorhandeneraeume2[i][2]=-1;
            }
            catch (NumberFormatException keineZahl) {
                vorhandeneraeume2[i][0]=-1;
                vorhandeneraeume2[i][1]=-1;
                vorhandeneraeume2[i][2]=-1;
            }
        }
        for (int i=0;i<vorhandeneraeume2.length;i++) {
            try {
                raumliste[vorhandeneraeume2[i][0]][vorhandeneraeume2[i][1]][vorhandeneraeume2[i][2]] = new Raum(vorhandeneraeume2[i][0],vorhandeneraeume2[i][1],vorhandeneraeume2[i][2],stockwerke,xraeume,yraeume,vorhandeneraeume2);
            }
            catch (ArrayIndexOutOfBoundsException ungueltigerraumeintrag) {
            }
        }
    }
    
    /** diese Methode ndert den aktuelle Raum, falls das mglich ist. Hierzu
     * werden Richtungsinformationen aus dem aktuellen Raum herangezogen.
     * Ist eine nderung mglich, wird automatisch auch die Uhrzeit erhht. */
    private boolean raumaendern(int xaendern,int yaendern,int zaendern) {
        if (((xaendern<0)&&(aktuellerraum.unten()))||
        ((xaendern>0)&&(aktuellerraum.oben()))||
        ((yaendern<0)&&(aktuellerraum.sueden()))||
        ((yaendern>0)&&(aktuellerraum.norden()))||
        ((zaendern<0)&&(aktuellerraum.westen()))||
        ((zaendern>0)&&(aktuellerraum.osten()))) {
            if (raumliste[xjetzt+xaendern][yjetzt+yaendern][zjetzt+zaendern]==null) {
                return raumaendern(Zahl.inkrement(xaendern),Zahl.inkrement(yaendern),Zahl.inkrement(zaendern));
            }
            else {
                aktuellerraum = raumliste[xjetzt+xaendern][yjetzt+yaendern][zjetzt+zaendern];
                xjetzt+=xaendern;
                yjetzt+=yaendern;
                zjetzt+=zaendern;
                uhr.uhrzeitErhoehen();
                return true;
            }
        }
        else {
            return false;
        }
    }
    
    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */
    public void norden() {
        boolean tmp = raumaendern(0,1,0);
    }
    
    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */
    public void sueden() {
        boolean tmp = raumaendern(0,-1,0);
    }

    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */
    public void osten() {
        boolean tmp = raumaendern(0,0,1);
    }

    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */    
    public void westen() {
        boolean tmp = raumaendern(0,0,-1);
    }

    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */
    public void oben() {
        boolean tmp = raumaendern(1,0,0);
    }

    /** versucht, den aktuellen Raum in die genannte Richtung
     * zu ndern */
    public void unten() {
        boolean tmp = raumaendern(-1,0,0);
    }
    
    public static void main (String[] args) {
    }
    
}
